package gregapi.block.multitileentity;

import static gregapi.data.CS.W;
import static net.minecraftforge.common.util.ForgeDirection.UP;
import gregapi.block.IBlockMaterial;
import gregapi.block.IBlockRetrievable;
import gregapi.block.IBlockSyncData.IBlockSyncDataAndCoversAndIDs;
import gregapi.block.IBlockToolable;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_AddCollisionBoxesToList;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_AddDestroyEffects;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_AddHitEffects;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_BeginLeavesDecay;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_BreakBlock;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_CanBeReplacedByLeaves;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_CanBlockStay;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_CanConnectRedstone;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_CanCreatureSpawn;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_CanEntityDestroy;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_CanPlaceTorchOnTop;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_CanSustainLeaves;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_CanSustainPlant;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_CollisionRayTrace;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_DropXpOnBlockBreak;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_FillWithRain;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetBedDirection;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetBedSpawnPosition;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetBlockHardness;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetBlocksMovement;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetCollisionBoundingBoxFromPool;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetComparatorInputOverride;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetDrops;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetEnchantPowerBonus;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetExplosionResistance;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetFireSpreadSpeed;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetFlammability;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetLightOpacity;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetLightValue;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetMaterialAtSide;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetMixedBrightnessForBlock;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetPickBlock;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetPlayerRelativeBlockHardness;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetSelectedBoundingBoxFromPool;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetStackFromBlock;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetValidRotations;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetWeakChanges;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsAir;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsBeaconBase;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsBed;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsBedFoot;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsBlockSolid;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsBurning;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsFertile;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsFireSource;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsFoliage;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsLadder;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsLeaves;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsNormalCube;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsProvidingStrongPower;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsProvidingWeakPower;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsReplaceable;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsReplaceableOreGen;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsSideSolid;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_IsWood;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnBlockActivated;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnBlockAdded;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnBlockClicked;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnBlockDestroyedByExplosion;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnBlockDestroyedByPlayer;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnBlockExploded;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnBlockHarvested;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnBlockPreDestroy;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnEntityCollidedWithBlock;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnEntityWalking;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnFallenUpon;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnNeighborBlockChange;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnNeighborChange;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnPlantGrow;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnToolClick;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_RandomDisplayTick;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_RecolourBlock;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_RemoveMaterialFromSide;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_RemovedByPlayer;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_RotateBlock;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SetBedOccupied;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SetBlockBoundsBasedOnState;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_ShouldCheckWeakPower;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_ShouldSideBeRendered;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataByte;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataByteArray;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataCovers;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataInteger;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataLong;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataShort;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_UpdateTick;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_VelocityToAddToEntity;
import gregapi.code.ArrayListNoNulls;
import gregapi.network.INetworkHandler;
import gregapi.old.Textures;
import gregapi.oredict.OreDictMaterialStack;
import gregapi.render.IRenderedBlock;
import gregapi.render.IRenderedBlockObject;
import gregapi.render.ITexture;
import gregapi.render.RendererBlockTextured;
import gregapi.tileentity.ITileEntity;
import gregapi.util.UT;

import java.util.*;

import net.minecraft.block.Block;
import net.minecraft.block.ITileEntityProvider;
import net.minecraft.block.material.Material;
import net.minecraft.client.particle.EffectRenderer;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.StatList;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.*;
import net.minecraft.world.Explosion;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.common.IPlantable;
import net.minecraftforge.common.util.ForgeDirection;
import net.minecraftforge.event.ForgeEventFactory;
import cpw.mods.fml.common.registry.GameRegistry;

/**
 * @author Gregorius Techneticies
 */
public class MultiTileEntityBlock extends Block implements IBlockSyncDataAndCoversAndIDs, IRenderedBlock, ITileEntityProvider, IBlockToolable, IBlockRetrievable, IBlockMaterial {
	/** There are quite some odd timings in the Block breaking Code which require the TileEntity to be buffered. */
	public static ThreadLocal<TileEntity> sTemporaryTileEntity = new ThreadLocal<TileEntity>();
	
	private final int mHarvestLevelOffset, mHarvestLevelMinimum, mHarvestLevelMaximum;
	private final String mNameInternal, mTool;
	private final boolean mOpaque, mNormalCube;
	
	private static final Map<String, MultiTileEntityBlock> MULTITILEENTITYBLOCKMAP = new HashMap<String, MultiTileEntityBlock>();
	
	public static String getName(String aNameOfVanillaMaterialField, Material aVanillaMaterial, SoundType aSoundType, String aTool, int aHarvestLevelOffset, int aHarvestLevelMinimum, int aHarvestLevelMaximum, boolean aOpaque, boolean aNormalCube) {
		return "gt.block.multitileentity." + aNameOfVanillaMaterialField + "." + aSoundType.soundName + "." + aTool + "." + aHarvestLevelOffset + "." + aHarvestLevelMinimum + "." + aHarvestLevelMaximum + "." + aOpaque + "." + aNormalCube;
	}
	
	public static MultiTileEntityBlock getOrCreate(String aNameOfVanillaMaterialField, Material aVanillaMaterial, SoundType aSoundType, String aTool, int aHarvestLevelOffset, int aHarvestLevelMinimum, int aHarvestLevelMaximum, boolean aOpaque, boolean aNormalCube) {
		MultiTileEntityBlock rBlock = MULTITILEENTITYBLOCKMAP.get(getName(aNameOfVanillaMaterialField, aVanillaMaterial, aSoundType, aTool = aTool.toLowerCase(), aHarvestLevelOffset, aHarvestLevelMinimum, aHarvestLevelMaximum, aOpaque, aNormalCube));
		return rBlock == null ? new MultiTileEntityBlock(aNameOfVanillaMaterialField, aVanillaMaterial, aSoundType, aTool, aHarvestLevelOffset, aHarvestLevelMinimum, aHarvestLevelMaximum, aOpaque, aNormalCube) : rBlock;
	}
	
	/**
	 * @param aNameOfVanillaMaterialField the Name of the vanilla Material Field. In case this is not a vanilla Material, insert the Name you want to give your own Material instead.
	 * @param aVanillaMaterial the Material used to determine the Block.
	 * @param aSoundType the Sound Type of the Block.
	 * @param aTool the Tool used to harvest this Block.
	 * @param aHarvestLevelOffset
	 * @param aHarvestLevelMinimum
	 * @param aHarvestLevelMaximum
	 * @param aOpaque if this Block is Opaque.
	 * @param aNormalCube if this Block is a normal Cube (for Redstone Stuff).
	 */
	private MultiTileEntityBlock(String aNameOfVanillaMaterialField, Material aVanillaMaterial, SoundType aSoundType, String aTool, int aHarvestLevelOffset, int aHarvestLevelMinimum, int aHarvestLevelMaximum, boolean aOpaque, boolean aNormalCube) {
		super(aVanillaMaterial);
		mNameInternal = getName(aNameOfVanillaMaterialField, aVanillaMaterial, aSoundType, aTool, aHarvestLevelOffset, aHarvestLevelMinimum, aHarvestLevelMaximum, aOpaque, aNormalCube);
		GameRegistry.registerBlock(this, ItemBlock.class, mNameInternal);
		MULTITILEENTITYBLOCKMAP.put(mNameInternal, this);
		
		setStepSound(aSoundType);
		mOpaque = aOpaque;
		mNormalCube = aNormalCube;
		
		mTool = aTool.toLowerCase();
		mHarvestLevelOffset = aHarvestLevelOffset;
		mHarvestLevelMinimum = Math.max(0, aHarvestLevelMinimum);
		mHarvestLevelMaximum = Math.max(aHarvestLevelMinimum, aHarvestLevelMaximum);
		
        opaque = this.isOpaqueCube();
        lightOpacity = this.isOpaqueCube() ? 255 : 0;
        
        try {ic2.api.tile.ExplosionWhitelist.addWhitelistedBlock(this);} catch(Throwable e) {/**/}
        try {codechicken.nei.api.API.hideItem(new ItemStack(this, 1, W));} catch(Throwable e) {/**/}
	}
	
	private static boolean LOCK = false;
	
	// You want to override one of those Functions with your TileEntity? Just implement the Interfaces of MultiTileEntityInterfaces on your TileEntity and you are done.
	@Override public final void receiveDataByte			(IBlockAccess aWorld, int aX, int aY, int aZ, byte   aData, INetworkHandler aNetworkHandler)																						{TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_SyncDataByte		) ((IMTE_SyncDataByte		)aTileEntity).receiveDataByte		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataShort		(IBlockAccess aWorld, int aX, int aY, int aZ, short  aData, INetworkHandler aNetworkHandler)																						{TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_SyncDataShort		) ((IMTE_SyncDataShort		)aTileEntity).receiveDataShort		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataInteger		(IBlockAccess aWorld, int aX, int aY, int aZ, int    aData, INetworkHandler aNetworkHandler)																						{TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_SyncDataInteger		) ((IMTE_SyncDataInteger	)aTileEntity).receiveDataInteger	(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataLong			(IBlockAccess aWorld, int aX, int aY, int aZ, long   aData, INetworkHandler aNetworkHandler)																						{TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_SyncDataLong		) ((IMTE_SyncDataLong		)aTileEntity).receiveDataLong		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataByteArray	(IBlockAccess aWorld, int aX, int aY, int aZ, byte[] aData, INetworkHandler aNetworkHandler)																						{TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_SyncDataByteArray	) ((IMTE_SyncDataByteArray	)aTileEntity).receiveDataByteArray	(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveData				(IBlockAccess aWorld, int aX, int aY, int aZ              , INetworkHandler aNetworkHandler, short aID1, short aID2)																{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataByte			(IBlockAccess aWorld, int aX, int aY, int aZ, byte   aData, INetworkHandler aNetworkHandler, short aID1, short aID2)																{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataByte			) ((IMTE_SyncDataByte		)aTileEntity).receiveDataByte		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataShort		(IBlockAccess aWorld, int aX, int aY, int aZ, short  aData, INetworkHandler aNetworkHandler, short aID1, short aID2)																{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataShort		) ((IMTE_SyncDataShort		)aTileEntity).receiveDataShort		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataInteger		(IBlockAccess aWorld, int aX, int aY, int aZ, int    aData, INetworkHandler aNetworkHandler, short aID1, short aID2)																{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataInteger		) ((IMTE_SyncDataInteger	)aTileEntity).receiveDataInteger	(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataLong			(IBlockAccess aWorld, int aX, int aY, int aZ, long   aData, INetworkHandler aNetworkHandler, short aID1, short aID2)																{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataLong			) ((IMTE_SyncDataLong		)aTileEntity).receiveDataLong		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataByteArray	(IBlockAccess aWorld, int aX, int aY, int aZ, byte[] aData, INetworkHandler aNetworkHandler, short aID1, short aID2)																{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataByteArray	) ((IMTE_SyncDataByteArray	)aTileEntity).receiveDataByteArray	(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveData				(IBlockAccess aWorld, int aX, int aY, int aZ              , INetworkHandler aNetworkHandler, short aID1, short aID2, short[] aCoverIDs, short[] aCoverMetas, short[] aCoverVisuals)	{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) {((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverIDs, aCoverMetas, aNetworkHandler); ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler);} ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataByte			(IBlockAccess aWorld, int aX, int aY, int aZ, byte aData  , INetworkHandler aNetworkHandler, short aID1, short aID2, short[] aCoverIDs, short[] aCoverMetas, short[] aCoverVisuals)	{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) {((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverIDs, aCoverMetas, aNetworkHandler); ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler);} if (aTileEntity instanceof IMTE_SyncDataByte		) ((IMTE_SyncDataByte		)aTileEntity).receiveDataByte		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataShort		(IBlockAccess aWorld, int aX, int aY, int aZ, short aData , INetworkHandler aNetworkHandler, short aID1, short aID2, short[] aCoverIDs, short[] aCoverMetas, short[] aCoverVisuals)	{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) {((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverIDs, aCoverMetas, aNetworkHandler); ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler);} if (aTileEntity instanceof IMTE_SyncDataShort		) ((IMTE_SyncDataShort		)aTileEntity).receiveDataShort		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataInteger		(IBlockAccess aWorld, int aX, int aY, int aZ, int aData   , INetworkHandler aNetworkHandler, short aID1, short aID2, short[] aCoverIDs, short[] aCoverMetas, short[] aCoverVisuals)	{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) {((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverIDs, aCoverMetas, aNetworkHandler); ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler);} if (aTileEntity instanceof IMTE_SyncDataInteger	) ((IMTE_SyncDataInteger	)aTileEntity).receiveDataInteger	(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataLong			(IBlockAccess aWorld, int aX, int aY, int aZ, long aData  , INetworkHandler aNetworkHandler, short aID1, short aID2, short[] aCoverIDs, short[] aCoverMetas, short[] aCoverVisuals)	{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) {((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverIDs, aCoverMetas, aNetworkHandler); ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler);} if (aTileEntity instanceof IMTE_SyncDataLong		) ((IMTE_SyncDataLong		)aTileEntity).receiveDataLong		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataByteArray	(IBlockAccess aWorld, int aX, int aY, int aZ, byte[] aData, INetworkHandler aNetworkHandler, short aID1, short aID2, short[] aCoverIDs, short[] aCoverMetas, short[] aCoverVisuals)	{if (!(aWorld instanceof World)) return; MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(aID1); if (tRegistry == null) return; TileEntity aTileEntity = tRegistry.getNewTileEntity(aID2); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) {((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverIDs, aCoverMetas, aNetworkHandler); ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler);} if (aTileEntity instanceof IMTE_SyncDataByteArray	) ((IMTE_SyncDataByteArray	)aTileEntity).receiveDataByteArray	(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveData				(IBlockAccess aWorld, int aX, int aY, int aZ              , INetworkHandler aNetworkHandler, short[] aCoverVisuals)																	{if (!(aWorld instanceof World)) return; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataByte			(IBlockAccess aWorld, int aX, int aY, int aZ, byte aData  , INetworkHandler aNetworkHandler, short[] aCoverVisuals)																	{if (!(aWorld instanceof World)) return; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler); if (aTileEntity instanceof IMTE_SyncDataByte			) ((IMTE_SyncDataByte		)aTileEntity).receiveDataByte		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataShort		(IBlockAccess aWorld, int aX, int aY, int aZ, short aData , INetworkHandler aNetworkHandler, short[] aCoverVisuals)																	{if (!(aWorld instanceof World)) return; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler); if (aTileEntity instanceof IMTE_SyncDataShort		) ((IMTE_SyncDataShort		)aTileEntity).receiveDataShort		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataInteger		(IBlockAccess aWorld, int aX, int aY, int aZ, int aData   , INetworkHandler aNetworkHandler, short[] aCoverVisuals)																	{if (!(aWorld instanceof World)) return; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler); if (aTileEntity instanceof IMTE_SyncDataInteger		) ((IMTE_SyncDataInteger	)aTileEntity).receiveDataInteger	(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataLong			(IBlockAccess aWorld, int aX, int aY, int aZ, long aData  , INetworkHandler aNetworkHandler, short[] aCoverVisuals)																	{if (!(aWorld instanceof World)) return; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler); if (aTileEntity instanceof IMTE_SyncDataLong			) ((IMTE_SyncDataLong		)aTileEntity).receiveDataLong		(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final void receiveDataByteArray	(IBlockAccess aWorld, int aX, int aY, int aZ, byte[] aData, INetworkHandler aNetworkHandler, short[] aCoverVisuals)																	{if (!(aWorld instanceof World)) return; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) return; UT.Worlds.setTileEntity((World)aWorld, aX, aY, aZ, aTileEntity, false); if (aTileEntity instanceof IMTE_SyncDataCovers) ((IMTE_SyncDataCovers)aTileEntity).receiveDataCovers(aCoverVisuals, aNetworkHandler); if (aTileEntity instanceof IMTE_SyncDataByteArray	) ((IMTE_SyncDataByteArray	)aTileEntity).receiveDataByteArray	(aData, aNetworkHandler); ((World)aWorld).markBlockForUpdate(aX, aY, aZ);}
	@Override public final boolean getBlocksMovement(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetBlocksMovement ? ((IMTE_GetBlocksMovement)aTileEntity).getBlocksMovement() : super.getBlocksMovement(aWorld, aX, aY, aZ);}
    @Override public final boolean isBlockSolid(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsBlockSolid ? ((IMTE_IsBlockSolid)aTileEntity).isBlockSolid((byte)aSide) : super.isBlockSolid(aWorld, aX, aY, aZ, aSide);}
    @Override public final void addCollisionBoxesToList(World aWorld, int aX, int aY, int aZ, AxisAlignedBB aAABB, List aList, Entity aEntity) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_AddCollisionBoxesToList) ((IMTE_AddCollisionBoxesToList)aTileEntity).addCollisionBoxesToList(aAABB, aList, aEntity); else super.addCollisionBoxesToList(aWorld, aX, aY, aZ, aAABB, aList, aEntity);}
    @Override public final AxisAlignedBB getCollisionBoundingBoxFromPool(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetCollisionBoundingBoxFromPool ? ((IMTE_GetCollisionBoundingBoxFromPool)aTileEntity).getCollisionBoundingBoxFromPool() : super.getCollisionBoundingBoxFromPool(aWorld, aX, aY, aZ);}
    @Override public final void updateTick(World aWorld, int aX, int aY, int aZ, Random aRandom) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_UpdateTick) ((IMTE_UpdateTick)aTileEntity).updateTick(aRandom); else super.updateTick(aWorld, aX, aY, aZ, aRandom);}
    @Override public final void onBlockDestroyedByPlayer(World aWorld, int aX, int aY, int aZ, int aRandom) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) aTileEntity = sTemporaryTileEntity.get(); if (aTileEntity == null || aTileEntity.xCoord != aX || aTileEntity.yCoord != aY || aTileEntity.zCoord != aZ) aTileEntity = null; if (aTileEntity instanceof IMTE_OnBlockDestroyedByPlayer) ((IMTE_OnBlockDestroyedByPlayer)aTileEntity).onBlockDestroyedByPlayer(aRandom); else super.onBlockDestroyedByPlayer(aWorld, aX, aY, aZ, aRandom);}
    @Override public final void onBlockAdded(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_OnBlockAdded) ((IMTE_OnBlockAdded)aTileEntity).onBlockAdded(); else super.onBlockAdded(aWorld, aX, aY, aZ);}
    @Override public final void dropXpOnBlockBreak(World aWorld, int aX, int aY, int aZ, int aXP) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_DropXpOnBlockBreak) ((IMTE_DropXpOnBlockBreak)aTileEntity).dropXpOnBlockBreak(aXP); else super.dropXpOnBlockBreak(aWorld, aX, aY, aZ, aXP);}
    @Override public final MovingObjectPosition collisionRayTrace(World aWorld, int aX, int aY, int aZ, Vec3 aVectorA, Vec3 aVectorB) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_CollisionRayTrace ? ((IMTE_CollisionRayTrace)aTileEntity).collisionRayTrace(aVectorA, aVectorB) : super.collisionRayTrace(aWorld, aX, aY, aZ, aVectorA, aVectorB);}
    @Override public final void onBlockDestroyedByExplosion(World aWorld, int aX, int aY, int aZ, Explosion aExplosion) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_OnBlockDestroyedByExplosion) ((IMTE_OnBlockDestroyedByExplosion)aTileEntity).onBlockDestroyedByExplosion(aExplosion); else super.onBlockDestroyedByExplosion(aWorld, aX, aY, aZ, aExplosion);}
    @Override public final boolean onBlockActivated(World aWorld, int aX, int aY, int aZ, EntityPlayer aPlayer, int aSide, float aHitX, float aHitY, float aHitZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_OnBlockActivated ? ((IMTE_OnBlockActivated)aTileEntity).onBlockActivated(aPlayer, (byte)aSide, aHitX, aHitY, aHitZ) : super.onBlockActivated(aWorld, aX, aY, aZ, aPlayer, aSide, aHitX, aHitY, aHitZ);}
    @Override public final void onEntityWalking(World aWorld, int aX, int aY, int aZ, Entity aEntity) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_OnEntityWalking) ((IMTE_OnEntityWalking)aTileEntity).onEntityWalking(aEntity); else super.onEntityWalking(aWorld, aX, aY, aZ, aEntity);}
    @Override public final void onBlockClicked(World aWorld, int aX, int aY, int aZ, EntityPlayer aPlayer) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_OnBlockClicked) ((IMTE_OnBlockClicked)aTileEntity).onBlockClicked(aPlayer); else super.onBlockClicked(aWorld, aX, aY, aZ, aPlayer);}
    @Override public final void velocityToAddToEntity(World aWorld, int aX, int aY, int aZ, Entity aEntity, Vec3 aVector) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_VelocityToAddToEntity) ((IMTE_VelocityToAddToEntity)aTileEntity).velocityToAddToEntity(aEntity, aVector); else super.velocityToAddToEntity(aWorld, aX, aY, aZ, aEntity, aVector);}
    @Override public final void setBlockBoundsBasedOnState(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_SetBlockBoundsBasedOnState) ((IMTE_SetBlockBoundsBasedOnState)aTileEntity).setBlockBoundsBasedOnState(); else super.setBlockBoundsBasedOnState(aWorld, aX, aY, aZ);}
    @Override public final int isProvidingWeakPower(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsProvidingWeakPower ? ((IMTE_IsProvidingWeakPower)aTileEntity).isProvidingWeakPower((byte)aSide) : super.isProvidingWeakPower(aWorld, aX, aY, aZ, aSide);}
    @Override public final void onEntityCollidedWithBlock(World aWorld, int aX, int aY, int aZ, Entity aEntity) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_OnEntityCollidedWithBlock) ((IMTE_OnEntityCollidedWithBlock)aTileEntity).onEntityCollidedWithBlock(aEntity); else super.onEntityCollidedWithBlock(aWorld, aX, aY, aZ, aEntity);}
    @Override public final int isProvidingStrongPower(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsProvidingStrongPower ? ((IMTE_IsProvidingStrongPower)aTileEntity).isProvidingStrongPower((byte)aSide) : super.isProvidingStrongPower(aWorld, aX, aY, aZ, aSide);}
    @Override public final boolean canBlockStay(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_CanBlockStay ? ((IMTE_CanBlockStay)aTileEntity).canBlockStay() : true;}
    @Override public final void onFallenUpon(World aWorld, int aX, int aY, int aZ, Entity aEntity, float aFallDistance) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_OnFallenUpon) ((IMTE_OnFallenUpon)aTileEntity).onFallenUpon(aEntity, aFallDistance); else super.onFallenUpon(aWorld, aX, aY, aZ, aEntity, aFallDistance);}
    @Override public final void onBlockHarvested(World aWorld, int aX, int aY, int aZ, int aMetaData, EntityPlayer aPlayer) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_OnBlockHarvested) ((IMTE_OnBlockHarvested)aTileEntity).onBlockHarvested(aMetaData, aPlayer); else super.onBlockHarvested(aWorld, aX, aY, aZ, aMetaData, aPlayer);}
    @Override public final void onBlockPreDestroy(World aWorld, int aX, int aY, int aZ, int aMetaData) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_OnBlockPreDestroy) ((IMTE_OnBlockPreDestroy)aTileEntity).onBlockPreDestroy(aMetaData); else super.onBlockPreDestroy(aWorld, aX, aY, aZ, aMetaData);}
    @Override public final void fillWithRain(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_FillWithRain) ((IMTE_FillWithRain)aTileEntity).fillWithRain(); else super.fillWithRain(aWorld, aX, aY, aZ);}
    @Override public final int getComparatorInputOverride(World aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetComparatorInputOverride ? ((IMTE_GetComparatorInputOverride)aTileEntity).getComparatorInputOverride((byte)aSide) : super.getComparatorInputOverride(aWorld, aX, aY, aZ, aSide);}
    @Override public final int getLightValue(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetLightValue ? ((IMTE_GetLightValue)aTileEntity).getLightValue() : super.getLightValue(aWorld, aX, aY, aZ);}
    @Override public final boolean isLadder(IBlockAccess aWorld, int aX, int aY, int aZ, EntityLivingBase aEntity) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsLadder ? ((IMTE_IsLadder)aTileEntity).isLadder(aEntity) : super.isLadder(aWorld, aX, aY, aZ, aEntity);}
    @Override public final boolean isNormalCube(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsNormalCube ? ((IMTE_IsNormalCube)aTileEntity).isNormalCube() : mNormalCube;}
    @Override public final boolean isReplaceable(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsReplaceable ? ((IMTE_IsReplaceable)aTileEntity).isReplaceable() : blockMaterial.isReplaceable();}
    @Override public final boolean isBurning(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsBurning ? ((IMTE_IsBurning)aTileEntity).isBurning() : false;}
    @Override public final boolean isAir(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsAir ? ((IMTE_IsAir)aTileEntity).isAir() : super.isAir(aWorld, aX, aY, aZ);}
    @Override public final boolean removedByPlayer(World aWorld, EntityPlayer aPlayer, int aX, int aY, int aZ, boolean aWillHarvest) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); sTemporaryTileEntity.set(aTileEntity); return aTileEntity instanceof IMTE_RemovedByPlayer ? ((IMTE_RemovedByPlayer)aTileEntity).removedByPlayer(aWorld, aPlayer, aWillHarvest) : super.removedByPlayer(aWorld, aPlayer, aX, aY, aZ, aWillHarvest);}
    @Override public final boolean canCreatureSpawn(EnumCreatureType aType, IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_CanCreatureSpawn ? ((IMTE_CanCreatureSpawn)aTileEntity).canCreatureSpawn(aType) : isSideSolid(aWorld, aX, aY, aZ, UP);}
    @Override public final boolean isBed(IBlockAccess aWorld, int aX, int aY, int aZ, EntityLivingBase aPlayer) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsBed ? ((IMTE_IsBed)aTileEntity).isBed(aPlayer) : false;}
    @Override public final ChunkCoordinates getBedSpawnPosition(IBlockAccess aWorld, int aX, int aY, int aZ, EntityPlayer aPlayer) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_VelocityToAddToEntity ? ((IMTE_GetBedSpawnPosition)aTileEntity).getBedSpawnPosition(aPlayer) : null;}
    @Override public final void setBedOccupied(IBlockAccess aWorld, int aX, int aY, int aZ, EntityPlayer aPlayer, boolean aOccupied) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_SetBedOccupied) ((IMTE_SetBedOccupied)aTileEntity).setBedOccupied(aPlayer, aOccupied);}
    @Override public final int getBedDirection(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetBedDirection ? ((IMTE_GetBedDirection)aTileEntity).getBedDirection() : 0;}
    @Override public final boolean isBedFoot(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsBedFoot ? ((IMTE_IsBedFoot)aTileEntity).isBedFoot() : false;}
    @Override public final void beginLeavesDecay(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_BeginLeavesDecay) ((IMTE_BeginLeavesDecay)aTileEntity).beginLeavesDecay(); else super.beginLeavesDecay(aWorld, aX, aY, aZ);}
    @Override public final boolean canSustainLeaves(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_CanSustainLeaves ? ((IMTE_CanSustainLeaves)aTileEntity).canSustainLeaves() : super.canSustainLeaves(aWorld, aX, aY, aZ);}
    @Override public final boolean isLeaves(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsLeaves ? ((IMTE_IsLeaves)aTileEntity).isLeaves() : super.isLeaves(aWorld, aX, aY, aZ);}
    @Override public final boolean canBeReplacedByLeaves(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_CanBeReplacedByLeaves ? ((IMTE_CanBeReplacedByLeaves)aTileEntity).canBeReplacedByLeaves() : false;}
    @Override public final boolean isWood(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsWood ? ((IMTE_IsWood)aTileEntity).isWood() : super.isWood(aWorld, aX, aY, aZ);}
    @Override public final boolean isReplaceableOreGen(World aWorld, int aX, int aY, int aZ, Block aTarget) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsReplaceableOreGen ? ((IMTE_IsReplaceableOreGen)aTileEntity).isReplaceableOreGen(aTarget) : super.isReplaceableOreGen(aWorld, aX, aY, aZ, aTarget);}
    @Override public final boolean canConnectRedstone(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_CanConnectRedstone ? ((IMTE_CanConnectRedstone)aTileEntity).canConnectRedstone((byte)aSide) : super.canConnectRedstone(aWorld, aX, aY, aZ, aSide);}
    @Override public final boolean canPlaceTorchOnTop(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_CanPlaceTorchOnTop ? ((IMTE_CanPlaceTorchOnTop)aTileEntity).canPlaceTorchOnTop() : isSideSolid(aWorld, aX, aY, aZ, UP);}
    @Override public final boolean isFoliage(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsFoliage ? ((IMTE_IsFoliage)aTileEntity).isFoliage() : super.isFoliage(aWorld, aX, aY, aZ);}
    @Override public final boolean canSustainPlant(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide, IPlantable aPlantable) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_CanSustainPlant ? ((IMTE_CanSustainPlant)aTileEntity).canSustainPlant((byte)aSide.ordinal(), aPlantable) : super.canSustainPlant(aWorld, aX, aY, aZ, aSide, aPlantable);}
    @Override public final void onPlantGrow(World aWorld, int aX, int aY, int aZ, int sX, int sY, int sZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_OnPlantGrow) ((IMTE_OnPlantGrow)aTileEntity).onPlantGrow(sX, sY, sZ); else super.onPlantGrow(aWorld, aX, aY, aZ, sX, sY, sZ);}
    @Override public final boolean isFertile(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsFertile ? ((IMTE_IsFertile)aTileEntity).isFertile() : false;}
    @Override public final boolean rotateBlock(World aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_RotateBlock ? ((IMTE_RotateBlock)aTileEntity).rotateBlock((byte)aSide.ordinal()) : false;}
    @Override public final ForgeDirection[] getValidRotations(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetValidRotations ? ((IMTE_GetValidRotations)aTileEntity).getValidRotations() : new ForgeDirection[0];}
    @Override public final float getEnchantPowerBonus(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetEnchantPowerBonus ? ((IMTE_GetEnchantPowerBonus)aTileEntity).getEnchantPowerBonus() : 0;}
    @Override public final boolean recolourBlock(World aWorld, int aX, int aY, int aZ, ForgeDirection aSide, int aColor) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_RecolourBlock ? ((IMTE_RecolourBlock)aTileEntity).recolourBlock((byte)aSide.ordinal(), (byte)aColor) : false;}
    @Override public final boolean shouldCheckWeakPower(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_ShouldCheckWeakPower ? ((IMTE_ShouldCheckWeakPower)aTileEntity).shouldCheckWeakPower((byte)aSide) : isNormalCube(aWorld, aX, aY, aZ);}
    @Override public final boolean getWeakChanges(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetWeakChanges ? ((IMTE_GetWeakChanges)aTileEntity).getWeakChanges() : super.getWeakChanges(aWorld, aX, aY, aZ);}
	@Override public final boolean addHitEffects(World aWorld, MovingObjectPosition aTarget, EffectRenderer aRenderer) {TileEntity aTileEntity = aWorld.getTileEntity(aTarget.blockX, aTarget.blockY, aTarget.blockZ); return aTileEntity instanceof IMTE_AddHitEffects ? ((IMTE_AddHitEffects)aTileEntity).addHitEffects(aWorld, aTarget, aRenderer) : super.addHitEffects(aWorld, aTarget, aRenderer);}
    @Override public final boolean addDestroyEffects(World aWorld, int aX, int aY, int aZ, int aMetaData, EffectRenderer aRenderer) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_AddDestroyEffects ? ((IMTE_AddDestroyEffects)aTileEntity).addDestroyEffects(aMetaData, aRenderer) : super.addDestroyEffects(aWorld, aX, aY, aZ, aMetaData, aRenderer);}
    @Override public final int getMixedBrightnessForBlock(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetMixedBrightnessForBlock ? ((IMTE_GetMixedBrightnessForBlock)aTileEntity).getMixedBrightnessForBlock() : super.getMixedBrightnessForBlock(aWorld, aX, aY, aZ);}
    @Override public final boolean shouldSideBeRendered(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_ShouldSideBeRendered ? ((IMTE_ShouldSideBeRendered)aTileEntity).shouldSideBeRendered((byte)aSide) : super.shouldSideBeRendered(aWorld, aX, aY, aZ, aSide);}
    @Override public final AxisAlignedBB getSelectedBoundingBoxFromPool(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetSelectedBoundingBoxFromPool ? ((IMTE_GetSelectedBoundingBoxFromPool)aTileEntity).getSelectedBoundingBoxFromPool() : super.getSelectedBoundingBoxFromPool(aWorld, aX, aY, aZ);}
    @Override public final void randomDisplayTick(World aWorld, int aX, int aY, int aZ, Random aRandom) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_RandomDisplayTick) ((IMTE_RandomDisplayTick)aTileEntity).randomDisplayTick(aRandom); else super.randomDisplayTick(aWorld, aX, aY, aZ, aRandom);}
    @Override public final void onBlockExploded(World aWorld, int aX, int aY, int aZ, Explosion aExplosion) {if (aWorld.isRemote) return; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMTE_OnBlockExploded) ((IMTE_OnBlockExploded)aTileEntity).onExploded(aExplosion); else aWorld.setBlockToAir(aX, aY, aZ);}
    @Override public final ItemStack getPickBlock(MovingObjectPosition aTarget, World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetPickBlock?((IMTE_GetPickBlock)aTileEntity).getPickBlock(aTarget):null;}
    @Override public final void breakBlock(World aWorld, int aX, int aY, int aZ, Block aBlock, int par6) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); sTemporaryTileEntity.set(aTileEntity); if (aTileEntity instanceof IMTE_BreakBlock) ((IMTE_BreakBlock)aTileEntity).breakBlock(); else aWorld.removeTileEntity(aX, aY, aZ);}
    @Override public final ItemStack getItemStackFromBlock(IBlockAccess aWorld, int aX, int aY, int aZ, byte aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetStackFromBlock?((IMTE_GetStackFromBlock)aTileEntity).getStackFromBlock(aSide):null;}
    @Override public final int getFlammability(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetFlammability ? ((IMTE_GetFlammability)aTileEntity).getFlammability((byte)aSide.ordinal()) : 0;}
    @Override public final int getFireSpreadSpeed(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetFireSpreadSpeed ? ((IMTE_GetFireSpreadSpeed)aTileEntity).getFireSpreadSpeed((byte)aSide.ordinal()) : 0;}
	@Override public final boolean isFireSource(World aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsFireSource ? ((IMTE_IsFireSource)aTileEntity).isFireSource((byte)aSide.ordinal()) : false;}
	@Override public final boolean canEntityDestroy(IBlockAccess aWorld, int aX, int aY, int aZ, Entity aEntity) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_CanEntityDestroy ? ((IMTE_CanEntityDestroy)aTileEntity).canEntityDestroy(aEntity) : true;}
	@Override public final long onToolClick(String aTool, long aRemainingDurability, Entity aPlayer, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, World aWorld, byte aSide, int aX, int aY, int aZ, float aHitX, float aHitY, float aHitZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_OnToolClick ? ((IMTE_OnToolClick)aTileEntity).onToolClick(aTool, aRemainingDurability, aPlayer, aPlayerInventory, aSneaking, aStack, aSide, aHitX, aHitY, aHitZ) : 0;}
	@Override public final OreDictMaterialStack getMaterialAtSide(IBlockAccess aWorld, int aX, int aY, int aZ, byte aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetMaterialAtSide?((IMTE_GetMaterialAtSide)aTileEntity).getMaterialAtSide(aSide):null;}
	@Override public final boolean removeMaterialFromSide(World aWorld, int aX, int aY, int aZ, byte aSide, OreDictMaterialStack aMaterial) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_RemoveMaterialFromSide ? ((IMTE_RemoveMaterialFromSide)aTileEntity).removeMaterialFromSide(aSide, aMaterial) : false;}
    @Override public final void dropBlockAsItemWithChance(World aWorld, int aX, int aY, int aZ, int aMeta, float aChance, int aFortune) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) aTileEntity = sTemporaryTileEntity.get(); if (aTileEntity == null || aTileEntity.xCoord != aX || aTileEntity.yCoord != aY || aTileEntity.zCoord != aZ) aTileEntity = null; if (aTileEntity instanceof IMTE_GetDrops) {ArrayListNoNulls<ItemStack> tList = ((IMTE_GetDrops)aTileEntity).getDrops(aFortune, false); aChance = ForgeEventFactory.fireBlockHarvesting(tList, aWorld, this, aX, aY, aZ, aMeta, aFortune, aChance, false, harvesters.get()); for (ItemStack tStack : tList) if (aWorld.rand.nextFloat() <= aChance) dropBlockAsItem(aWorld, aX, aY, aZ, tStack);}}
    @Override public final void harvestBlock(World aWorld, EntityPlayer aPlayer, int aX, int aY, int aZ, int aMeta) {aPlayer.addStat(StatList.mineBlockStatArray[getIdFromBlock(this)], 1); aPlayer.addExhaustion(0.025F); boolean aSilkTouch = EnchantmentHelper.getSilkTouchModifier(aPlayer); int aFortune = EnchantmentHelper.getFortuneModifier(aPlayer); float aChance = 1.0F; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) aTileEntity = sTemporaryTileEntity.get(); if (aTileEntity == null || aTileEntity.xCoord != aX || aTileEntity.yCoord != aY || aTileEntity.zCoord != aZ) aTileEntity = null; if (aTileEntity instanceof IMTE_GetDrops) {ArrayListNoNulls<ItemStack> tList = ((IMTE_GetDrops)aTileEntity).getDrops(aFortune, aSilkTouch); aChance = ForgeEventFactory.fireBlockHarvesting(tList, aWorld, this, aX, aY, aZ, aMeta, aFortune, aChance, aSilkTouch, harvesters.get()); for (ItemStack tStack : tList) if (aWorld.rand.nextFloat() <= aChance) dropBlockAsItem(aWorld, aX, aY, aZ, tStack);}}
    @Override public final ArrayList<ItemStack> getDrops(World aWorld, int aX, int aY, int aZ, int aUnusableMetaData, int aFortune) {ArrayListNoNulls<ItemStack> tList = new ArrayListNoNulls<ItemStack>(); TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) aTileEntity = sTemporaryTileEntity.get(); if (aTileEntity == null || aTileEntity.xCoord != aX || aTileEntity.yCoord != aY || aTileEntity.zCoord != aZ) aTileEntity = null; if (aTileEntity instanceof IMTE_GetDrops) tList = ((IMTE_GetDrops)aTileEntity).getDrops(aFortune, false); return tList;}
    @Override public final boolean isSideSolid(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsSideSolid?((IMTE_IsSideSolid)aTileEntity).isSideSolid((byte)aSide.ordinal()):mOpaque;}
    @Override public final boolean isBeaconBase(IBlockAccess aWorld, int aX, int aY, int aZ, int aBeaconX, int aBeaconY, int aBeaconZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_IsBeaconBase?((IMTE_IsBeaconBase)aTileEntity).isBeaconBase(aBeaconX, aBeaconY, aBeaconZ):false;}
    @Override public final int getLightOpacity(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetLightOpacity?((IMTE_GetLightOpacity)aTileEntity).getLightOpacity():mOpaque?255:0;}
	@Override public final boolean isOpaqueCube() {return mOpaque;}
	@Override public final boolean func_149730_j() {return mOpaque;}
	@Override public final boolean renderAsNormalBlock() {return mOpaque || mNormalCube;}
	@Override public final boolean isNormalCube()  {return mNormalCube;}
    @Override public final boolean canProvidePower() {return !mNormalCube;}
	@Override public final String getUnlocalizedName() {return mNameInternal;}
	@Override public final String getLocalizedName() {return StatCollector.translateToLocal(mNameInternal + ".name");}
	@Override public final String getHarvestTool(int aMaterialToolQuality) {return mTool;}
	@Override public final int getHarvestLevel(int aMaterialToolQuality) {return (int)UT.Code.bind(mHarvestLevelMinimum, mHarvestLevelMaximum, mHarvestLevelOffset + aMaterialToolQuality);}
	@Override public final boolean hasTileEntity(int aMeta) {return true;}
	@Override public final boolean canSilkHarvest() {return false;}
    @Override public final int getRenderBlockPass() {return 1;}
	@Override public final TileEntity createNewTileEntity(World aWorld, int aMeta) {return null;}
	@Override public final TileEntity createTileEntity(World aWorld, int aMeta) {return null;}
    @Override public final void getSubBlocks(Item aItem, CreativeTabs aCreativeTab, List aList) {/**/}
	@Override public final ITexture getTexture(int aRenderPass, byte aSide, short aMetaData) {return null;}
	@Override public final ITexture getTexture(int aRenderPass, byte aSide, IBlockAccess aWorld, int aX, int aY, int aZ) {return null;}
	@Override public final boolean setBlockBounds(int aRenderPass, byte aSide, short aMetaData) {return false;}
	@Override public final boolean setBlockBounds(int aRenderPass, byte aSide, IBlockAccess aWorld, int aX, int aY, int aZ) {return false;}
	@Override public final int getRenderPasses(byte aSide, short aMetaData) {return 0;}
	@Override public final int getRenderPasses(byte aSide, IBlockAccess aWorld, int aX, int aY, int aZ) {return 0;}
	@Override public final IRenderedBlockObject passRenderingToObject(short aMetaData) {return null;}
	@Override public final void registerBlockIcons(IIconRegister aIconRegister) {/**/}
    @Override public final IIcon getIcon(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {return Textures.BlockIcons.CFOAM_HARDENED.getIcon(0);}
    @Override public final IIcon getIcon(int aSide, int aMetaData) {return Textures.BlockIcons.CFOAM_HARDENED.getIcon(0);}
	@Override public final int getRenderType() {return RendererBlockTextured.INSTANCE==null?super.getRenderType():RendererBlockTextured.INSTANCE.mRenderID;}
	@Override public final IRenderedBlockObject passRenderingToObject(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity tTileEntity = aWorld.getTileEntity(aX, aY, aZ); return tTileEntity instanceof IRenderedBlockObject ? (IRenderedBlockObject)tTileEntity : null;}
	@Override public final boolean onBlockEventReceived(World aWorld, int aX, int aY, int aZ, int aID, int aData) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity == null || aTileEntity.receiveClientEvent(aID, aData);}
    @Override public final float getPlayerRelativeBlockHardness(EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetPlayerRelativeBlockHardness?((IMTE_GetPlayerRelativeBlockHardness)aTileEntity).getPlayerRelativeBlockHardness(aPlayer):super.getPlayerRelativeBlockHardness(aPlayer, aWorld, aX, aY, aZ);}
    @Override public final float getBlockHardness(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetBlockHardness?((IMTE_GetBlockHardness)aTileEntity).getBlockHardness():1.0F;}
    @Override public final float getExplosionResistance(Entity aExploder, World aWorld, int aX, int aY, int aZ, double aExplosionX, double aExplosionY, double aExplosionZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMTE_GetExplosionResistance?((IMTE_GetExplosionResistance	)aTileEntity).getExplosionResistance(aExploder, aExplosionX, aExplosionY, aExplosionZ):1.0F;}
    @Override public final void onNeighborChange(IBlockAccess aWorld, int aX, int aY, int aZ, int aTileX, int aTileY, int aTileZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (!LOCK) {LOCK = true; if (aTileEntity instanceof ITileEntity) ((ITileEntity)aTileEntity).onAdjacentBlockChange(aTileX, aTileY, aTileZ); LOCK = false;} if (aTileEntity instanceof IMTE_OnNeighborChange) ((IMTE_OnNeighborChange)aTileEntity).onNeighborChange(aWorld, aTileX, aTileY, aTileZ);}
    @Override public final void onNeighborBlockChange(World aWorld, int aX, int aY, int aZ, Block aBlock) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (!LOCK) {LOCK = true; if (aTileEntity instanceof ITileEntity) ((ITileEntity)aTileEntity).onAdjacentBlockChange(aX, aY, aZ); LOCK = false;} if (aTileEntity instanceof IMTE_OnNeighborBlockChange) ((IMTE_OnNeighborBlockChange)aTileEntity).onNeighborBlockChange(aWorld, aBlock);}
}