package gregapi.tileentity;

import gregapi.block.multitileentity.IMultiTileEntity.IMTE_BreakBlock;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnBlockExploded;
import gregapi.block.multitileentity.MultiTileEntityRegistry;
import gregapi.util.UT;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.world.Explosion;

/**
 * @author Gregorius Techneticies
 */
public abstract class TileEntityBase5 extends TileEntityBase4 implements IInventory, IMTE_OnBlockExploded, IMTE_BreakBlock {
	private static final ItemStack[] NULL_INVENTORY = new ItemStack[0];
	
	protected ItemStack[] mInventory = NULL_INVENTORY;
	
    @Override
	public void readFromNBT2(NBTTagCompound aNBT) {
        // Standard readFromNBT process to load Inventory.
        mInventory = new ItemStack[aNBT.getShort("gt.invsize")];
        NBTTagList tList = aNBT.getTagList("gt.invlist", 10);
        for (int i = 0; i < tList.tagCount(); i++) {
            NBTTagCompound tNBT = tList.getCompoundTagAt(i);
            int tSlot = tNBT.getShort("s");
            if (tSlot >= 0 && tSlot < mInventory.length) mInventory[tSlot] = UT.Stacks.load(tNBT);
        }
    }
    
    @Override
	public void writeToNBT2(NBTTagCompound aNBT) {
        NBTTagList tList = new NBTTagList();
        for (short tSlot = 0; tSlot < mInventory.length; tSlot++) if (mInventory[tSlot] != null) {
            NBTTagCompound tNBT = UT.NBT.getNBTShort(null, "s", tSlot);
            mInventory[tSlot].writeToNBT(tNBT);
            tList.appendTag(tNBT);
        }
        aNBT.setTag("gt.invlist", tList);
    }
    
	@Override public void onExploded(Explosion aExplosion) {for (int i = 0; i < mInventory.length; i++) if (worldObj.rand.nextInt(3) != 0) mInventory[i] = null; worldObj.setBlockToAir(xCoord, yCoord, zCoord);}
	@Override public ItemStack decrStackSize(int aSlot, int aDecrement) {if (mInventory[aSlot] != null) {if (mInventory[aSlot].stackSize <= aDecrement) {ItemStack tStack = mInventory[aSlot]; mInventory[aSlot] = null; return tStack;} ItemStack rStack = mInventory[aSlot].splitStack(aDecrement); if (mInventory[aSlot].stackSize <= 0) mInventory[aSlot] = null; return rStack;} return null;}
	@Override public ItemStack getStackInSlotOnClosing(int aSlot) {ItemStack rStack = mInventory[aSlot]; mInventory[aSlot] = null; return rStack;}
    @Override public ItemStack getStackInSlot(int aSlot) {return mInventory[aSlot];}
	@Override public String getInventoryName() {MultiTileEntityRegistry tRegistry = MultiTileEntityRegistry.getRegistry(getMultiTileEntityRegistryID()); return tRegistry==null?getClass().getName():tRegistry.getLocal(getMultiTileEntityID());}
	@Override public int getSizeInventory() {return mInventory==null?0:mInventory.length;}
	@Override public int getInventoryStackLimit() {return 64;}
	@Override public void setInventorySlotContents(int aSlot, ItemStack aStack) {mInventory[aSlot] = aStack;}
	@Override public boolean hasCustomInventoryName() {return false;}
	@Override public boolean isUseableByPlayer(EntityPlayer aPlayer) {return aPlayer.getDistanceSq(xCoord + 0.5D, yCoord + 0.5D, zCoord + 0.5D) <= 64D;}
	@Override public void openInventory () {/**/}
    @Override public void closeInventory() {/**/}
	@Override public boolean isItemValidForSlot(int aSlot, ItemStack aStack) {return true;}
	@Override public void breakBlock() {if (!worldObj.isRemote) for (short i = 0; i < mInventory.length; i++) if (mInventory[i] != null && canDrop(i)) worldObj.spawnEntityInWorld(new EntityItem(worldObj, xCoord+0.5, yCoord+0.5, zCoord+0.5, UT.Stacks.copy(mInventory[i])));}
}